=encoding utf8

=head1 NAME

Mail::Box::Collection - a collection of subfolders

=head1 INHERITANCE

 Mail::Box::Collection
   is a User::Identity::Collection
   is a User::Identity::Item

 Mail::Box::Collection
   is a Mail::Reporter

=head1 SYNOPSIS

=head1 DESCRIPTION

The L<Mail::Box::Collection|Mail::Box::Collection> object maintains a set L<Mail::Box::Identity|Mail::Box::Identity>
objects, each describing a the location of a single mailbox (folder).  The
collection is used by the L<Mail::Box::Manage::User|Mail::Box::Manage::User> object to administer
the folders of a single user, even if those folders are closed.

Extends L<"DESCRIPTION" in Mail::Reporter|Mail::Reporter/"DESCRIPTION">.

Extends L<"DESCRIPTION" in User::Identity::Collection|User::Identity::Collection/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in User::Identity::Collection|User::Identity::Collection/"OVERLOADED">.

=over 4

=item overload: B<""> stringification

Inherited, see L<User::Identity::Collection/"OVERLOADED">

=item overload: B<@{}> array dereference

Inherited, see L<User::Identity::Collection/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Reporter|Mail::Reporter/"METHODS">.

Extends L<"METHODS" in User::Identity::Collection|User::Identity::Collection/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Reporter|Mail::Reporter/"Constructors">.

Extends L<"Constructors" in User::Identity::Collection|User::Identity::Collection/"Constructors">.

=over 4

=item $class-E<gt>B<new>( [$name], %options )

Inherited, see L<Mail::Reporter/"Constructors">

 -Option     --Defined in                --Default
  description  User::Identity::Item        undef
  folder_type                              <from parent>
  item_type    User::Identity::Collection  Mail::Box::Identity
  manager                                  <from parent>
  name         User::Identity::Item        'folders'
  parent       User::Identity::Item        undef
  roles        User::Identity::Collection  undef

=over 2

=item description => STRING

=item folder_type => $class

=item item_type => CLASS

=item manager => $object

A pre-prepared L<Mail::Box::Manager|Mail::Box::Manager> C<$object> (could be a L<Mail::Box::Manage::User|Mail::Box::Manage::User>).

=item name => STRING

=item parent => OBJECT

=item roles => $role|\@roles

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Reporter|Mail::Reporter/"Attributes">.

Extends L<"Attributes" in User::Identity::Collection|User::Identity::Collection/"Attributes">.

=over 4

=item $obj-E<gt>B<description>()

Inherited, see L<User::Identity::Item/"Attributes">

=item $obj-E<gt>B<folderType>( [$folderclass] )

Returns the type of folder (on this location).  When specified, then
C<$folderclass> must be a L<Mail::Box|Mail::Box> extension.

=encoding utf8

=pod

=item $obj-E<gt>B<itemType>()

Inherited, see L<User::Identity::Collection/"Attributes">

=item $obj-E<gt>B<manager>()

The L<Mail::Box::Manager|Mail::Box::Manager> (usually a L<Mail::Box::Manage::User|Mail::Box::Manage::User> object),
which is handling the opening of folders.

=item $obj-E<gt>B<name>( [$newname] )

Inherited, see L<User::Identity::Item/"Attributes">

=item $obj-E<gt>B<roles>()

Inherited, see L<User::Identity::Collection/"Attributes">

=back

=head2 Collections

Extends L<"Collections" in User::Identity::Collection|User::Identity::Collection/"Collections">.

=over 4

=item $obj-E<gt>B<add>($collection, $role)

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<addCollection>( $object | <[$type], %options> )

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<collection>($name)

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<parent>( [$parent] )

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<removeCollection>($object|$name)

Inherited, see L<User::Identity::Item/"Collections">

=item $any-E<gt>B<type>()

Inherited, see L<User::Identity::Item/"Collections">

=item $obj-E<gt>B<user>()

Inherited, see L<User::Identity::Item/"Collections">

=back

=head2 Maintaining roles

Extends L<"Maintaining roles" in User::Identity::Collection|User::Identity::Collection/"Maintaining roles">.

=over 4

=item $obj-E<gt>B<addRole>($role|([$name], %options))

Inherited, see L<User::Identity::Collection/"Maintaining roles">

=item $obj-E<gt>B<removeRole>($role|$name)

Inherited, see L<User::Identity::Collection/"Maintaining roles">

=item $obj-E<gt>B<renameRole>( <$role|$oldname>, $newname )

Inherited, see L<User::Identity::Collection/"Maintaining roles">

=item $obj-E<gt>B<sorted>()

Inherited, see L<User::Identity::Collection/"Maintaining roles">

=back

=head2 Searching

Extends L<"Searching" in User::Identity::Collection|User::Identity::Collection/"Searching">.

=over 4

=item $obj-E<gt>B<find>($name|CODE|undef)

Inherited, see L<User::Identity::Collection/"Searching">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Reporter|Mail::Reporter/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Reporter|Mail::Reporter/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: cannot create a $type to add this to my collection.

Some options are specified to create a C<$type> object, which is native to
this collection.  However, for some reason this failed.
Cast by C<addRole()>

=item Error: cannot load collection module for $type ($class): $@

Either the specified C<$type> does not exist, or that module named C<$class> returns
compilation errors.  If the type as specified in the warning is not
the name of a package, you specified a nickname which was not defined.
Maybe you forgot the 'require' the package which defines the nickname.
Cast by C<addCollection()>

=item Error: cannot rename $from into $to: already exists.

Cast by C<renameRole()>

=item Error: cannot rename $from into $to: doesn't exist.

Cast by C<renameRole()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: nvalid collection $name.

The collection with C<$name> does not exist and can not be created.
Cast by C<add()>

=item Error: this $object is not a collection.

Cast by C<addCollection()>

=item Error: wrong type of role for $collection: requires a $expect but got a $type.

Each C<$collection> groups sets of roles of one specific type (C<$expect>).  You
cannot add objects of a different C<$type>.
Cast by C<addRole()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.01,
built on December 13, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

